import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MedialiveMultiplexProgramConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#multiplex_id MedialiveMultiplexProgram#multiplex_id}
    */
    readonly multiplexId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#program_name MedialiveMultiplexProgram#program_name}
    */
    readonly programName: string;
    /**
    * multiplex_program_settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#multiplex_program_settings MedialiveMultiplexProgram#multiplex_program_settings}
    */
    readonly multiplexProgramSettings: MedialiveMultiplexProgramMultiplexProgramSettings;
}
export interface MedialiveMultiplexProgramMultiplexProgramSettingsServiceDescriptor {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#provider_name MedialiveMultiplexProgram#provider_name}
    */
    readonly providerName: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#service_name MedialiveMultiplexProgram#service_name}
    */
    readonly serviceName: string;
}
export declare function medialiveMultiplexProgramMultiplexProgramSettingsServiceDescriptorToTerraform(struct?: MedialiveMultiplexProgramMultiplexProgramSettingsServiceDescriptorOutputReference | MedialiveMultiplexProgramMultiplexProgramSettingsServiceDescriptor): any;
export declare class MedialiveMultiplexProgramMultiplexProgramSettingsServiceDescriptorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MedialiveMultiplexProgramMultiplexProgramSettingsServiceDescriptor | undefined;
    set internalValue(value: MedialiveMultiplexProgramMultiplexProgramSettingsServiceDescriptor | undefined);
    private _providerName?;
    get providerName(): string;
    set providerName(value: string);
    get providerNameInput(): string | undefined;
    private _serviceName?;
    get serviceName(): string;
    set serviceName(value: string);
    get serviceNameInput(): string | undefined;
}
export interface MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsStatemuxSettings {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#maximum_bitrate MedialiveMultiplexProgram#maximum_bitrate}
    */
    readonly maximumBitrate?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#minimum_bitrate MedialiveMultiplexProgram#minimum_bitrate}
    */
    readonly minimumBitrate?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#priority MedialiveMultiplexProgram#priority}
    */
    readonly priority?: number;
}
export declare function medialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsStatemuxSettingsToTerraform(struct?: MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsStatemuxSettingsOutputReference | MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsStatemuxSettings): any;
export declare class MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsStatemuxSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsStatemuxSettings | undefined;
    set internalValue(value: MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsStatemuxSettings | undefined);
    private _maximumBitrate?;
    get maximumBitrate(): number;
    set maximumBitrate(value: number);
    resetMaximumBitrate(): void;
    get maximumBitrateInput(): number | undefined;
    private _minimumBitrate?;
    get minimumBitrate(): number;
    set minimumBitrate(value: number);
    resetMinimumBitrate(): void;
    get minimumBitrateInput(): number | undefined;
    private _priority?;
    get priority(): number;
    set priority(value: number);
    resetPriority(): void;
    get priorityInput(): number | undefined;
}
export interface MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettings {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#constant_bitrate MedialiveMultiplexProgram#constant_bitrate}
    */
    readonly constantBitrate?: number;
    /**
    * statemux_settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#statemux_settings MedialiveMultiplexProgram#statemux_settings}
    */
    readonly statemuxSettings?: MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsStatemuxSettings;
}
export declare function medialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsToTerraform(struct?: MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsOutputReference | MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettings): any;
export declare class MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettings | undefined;
    set internalValue(value: MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettings | undefined);
    private _constantBitrate?;
    get constantBitrate(): number;
    set constantBitrate(value: number);
    resetConstantBitrate(): void;
    get constantBitrateInput(): number | undefined;
    private _statemuxSettings;
    get statemuxSettings(): MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsStatemuxSettingsOutputReference;
    putStatemuxSettings(value: MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsStatemuxSettings): void;
    resetStatemuxSettings(): void;
    get statemuxSettingsInput(): MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsStatemuxSettings | undefined;
}
export interface MedialiveMultiplexProgramMultiplexProgramSettings {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#preferred_channel_pipeline MedialiveMultiplexProgram#preferred_channel_pipeline}
    */
    readonly preferredChannelPipeline: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#program_number MedialiveMultiplexProgram#program_number}
    */
    readonly programNumber: number;
    /**
    * service_descriptor block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#service_descriptor MedialiveMultiplexProgram#service_descriptor}
    */
    readonly serviceDescriptor?: MedialiveMultiplexProgramMultiplexProgramSettingsServiceDescriptor;
    /**
    * video_settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program#video_settings MedialiveMultiplexProgram#video_settings}
    */
    readonly videoSettings?: MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettings;
}
export declare function medialiveMultiplexProgramMultiplexProgramSettingsToTerraform(struct?: MedialiveMultiplexProgramMultiplexProgramSettingsOutputReference | MedialiveMultiplexProgramMultiplexProgramSettings): any;
export declare class MedialiveMultiplexProgramMultiplexProgramSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MedialiveMultiplexProgramMultiplexProgramSettings | undefined;
    set internalValue(value: MedialiveMultiplexProgramMultiplexProgramSettings | undefined);
    private _preferredChannelPipeline?;
    get preferredChannelPipeline(): string;
    set preferredChannelPipeline(value: string);
    get preferredChannelPipelineInput(): string | undefined;
    private _programNumber?;
    get programNumber(): number;
    set programNumber(value: number);
    get programNumberInput(): number | undefined;
    private _serviceDescriptor;
    get serviceDescriptor(): MedialiveMultiplexProgramMultiplexProgramSettingsServiceDescriptorOutputReference;
    putServiceDescriptor(value: MedialiveMultiplexProgramMultiplexProgramSettingsServiceDescriptor): void;
    resetServiceDescriptor(): void;
    get serviceDescriptorInput(): MedialiveMultiplexProgramMultiplexProgramSettingsServiceDescriptor | undefined;
    private _videoSettings;
    get videoSettings(): MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettingsOutputReference;
    putVideoSettings(value: MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettings): void;
    resetVideoSettings(): void;
    get videoSettingsInput(): MedialiveMultiplexProgramMultiplexProgramSettingsVideoSettings | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program aws_medialive_multiplex_program}
*/
export declare class MedialiveMultiplexProgram extends cdktf.TerraformResource {
    static readonly tfResourceType = "aws_medialive_multiplex_program";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/aws/r/medialive_multiplex_program aws_medialive_multiplex_program} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MedialiveMultiplexProgramConfig
    */
    constructor(scope: Construct, id: string, config: MedialiveMultiplexProgramConfig);
    get id(): string;
    private _multiplexId?;
    get multiplexId(): string;
    set multiplexId(value: string);
    get multiplexIdInput(): string | undefined;
    private _programName?;
    get programName(): string;
    set programName(value: string);
    get programNameInput(): string | undefined;
    private _multiplexProgramSettings;
    get multiplexProgramSettings(): MedialiveMultiplexProgramMultiplexProgramSettingsOutputReference;
    putMultiplexProgramSettings(value: MedialiveMultiplexProgramMultiplexProgramSettings): void;
    get multiplexProgramSettingsInput(): MedialiveMultiplexProgramMultiplexProgramSettings | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
